<script setup lang="ts">
import CardDropdownLinkItem from "@/components/molecules/card/CardDropdownLinkItem.vue";
import EntityCard from "@/components/organisms/card/vertical-card/entity-card/EntityCard.vue";
import Repository from "@/entities/Repository/Repository.js";
import {computed} from "vue";
import {useRepositoryNewVersionModalStore} from "@/stores/Repository/RepositoryNewVersionModalStore";

const props = defineProps<{ repository: Repository }>()
const newVersionModalStore = useRepositoryNewVersionModalStore();

const items = computed(() => {
  const code = props.repository.code;

  return [
    {
      link: null,
      action: () => newVersionModalStore.show(props.repository),
      key: 'new_version',
      label: 'Nouvelle version'
    },
    {
      link: '/repository/' + code + '/instance',
      action: null,
      key: 'show_instances',
      label: 'Voir les instances'
    },
    {
      link: '/repository/' + code + '/instance/new',
      action: null,
      key: 'add_instance',
      label: 'Ajouter une instance'
    },
    {
      link: '/repository/' + code,
      action: null,
      key: 'show',
      label: 'Afficher'
    },
    {
      link: '/repository/' + code + '/edit',
      action: null,
      key: 'update',
      label: 'Modifier'
    },
    {
      link: '/repository/' + code + '/delete',
      action: null,
      key: 'delete',
      label: 'Supprimer'
    },
  ]
})

</script>

<template>
  <EntityCard :title="repository.name" :link="'/repository/' +  repository.code" :img="repository.img">
    <template v-slot:menu>
      <CardDropdownLinkItem :link="item.link" :action="item.action" :key="'repository_menu_' + item.key" v-for="(item) of items">
        {{ item.label }}
      </CardDropdownLinkItem>
    </template>
  </EntityCard>
</template>
